

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 LimeGreen
#property indicator_color2 Red
#property indicator_color3 Red
#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_width3  2

extern int MATF            = 0;
extern int MAPeriod        = 20;
extern int MAma_shift      = 0;
extern int MAma_method     = MODE_SMA;
extern int MAapplied_price = PRICE_CLOSE;

double ma[];
double mada[];
double madb[];
double cross[];

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init() 
{
   IndicatorBuffers(4);
   SetIndexBuffer(0, ma);
   SetIndexBuffer(1, mada);
   SetIndexBuffer(2, madb);
   SetIndexBuffer(3, cross);
      MATF = MathMax(MATF,Period());
   return (0);
}
int deinit() { return(0); }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int start() 
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   double pr = 2.0/(MAPeriod+1);
   if (cross[limit]==-1) CleanPoint(limit,mada,madb);
   for (int i = limit; i>=0; i--) 
   {
      int y = iBarShift(Symbol(), MATF, Time[i]);
      double price = iMA(NULL,0,1,0,MODE_SMA,MAapplied_price,i);
      if(MAma_method==0)
            ma[i] = iMA(NULL, MATF, MAPeriod-1, MAma_shift,MAma_method,MAapplied_price, y+1)*(MAPeriod-1)/MAPeriod+price*1/MAPeriod;
      else  ma[i] = iMA(NULL, MATF, MAPeriod,   MAma_shift,MAma_method,MAapplied_price, y+1)*(1-pr)+price*pr;
      mada[i] = EMPTY_VALUE;
      madb[i] = EMPTY_VALUE;
      cross[i] = cross[i+1];
         if ( price > ma[i]) cross[i] =  1;
         if ( price < ma[i]) cross[i] = -1;
                     if (cross[i]==-1) PlotPoint(i,mada,madb,ma);
   }
   return (0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}